import type { Locale } from 'date-fns';
interface DateInputState {
    formatStr: string;
    localize: Locale['localize'];
    date?: Date | null;
    isControlledDate?: boolean;
}
declare function useDateInputState({ formatStr, localize, date, isControlledDate }: DateInputState): {
    dateField: {
        year: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        month: number | null;
        day: number | null;
        hour: number | null;
        minute: number | null;
        second: number | null;
        meridian: "AM" | "PM" | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    } | {
        month: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        year: number | null;
        day: number | null;
        hour: number | null;
        minute: number | null;
        second: number | null;
        meridian: "AM" | "PM" | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    } | {
        day: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        year: number | null;
        month: number | null;
        hour: number | null;
        minute: number | null;
        second: number | null;
        meridian: "AM" | "PM" | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    } | {
        hour: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        year: number | null;
        month: number | null;
        day: number | null;
        minute: number | null;
        second: number | null;
        meridian: "AM" | "PM" | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    } | {
        minute: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        year: number | null;
        month: number | null;
        day: number | null;
        hour: number | null;
        second: number | null;
        meridian: "AM" | "PM" | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    } | {
        second: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        year: number | null;
        month: number | null;
        day: number | null;
        hour: number | null;
        minute: number | null;
        meridian: "AM" | "PM" | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    } | {
        meridian: any;
        format: string;
        patternArray: {
            pattern: string;
            key: string;
        }[];
        year: number | null;
        month: number | null;
        day: number | null;
        hour: number | null;
        minute: number | null;
        second: number | null;
        constructor: Function;
        toString(): string;
        toLocaleString(): string;
        valueOf(): Object;
        hasOwnProperty(v: PropertyKey): boolean;
        isPrototypeOf(v: Object): boolean;
        propertyIsEnumerable(v: PropertyKey): boolean;
        should: Chai.Assertion;
    };
    setDateOffset: (pattern: string, offset: number, callback?: ((newDate: Date) => void) | undefined) => void;
    setDateField: (pattern: string, value: number | null, callback?: ((newDate: Date) => void) | undefined) => void;
    getDateField: (pattern: string) => {
        name: any;
        value: any;
    };
    toDateString: () => string;
};
export default useDateInputState;
